Subject: Re: What's cooking in git.git (Jan 2025, #06; Wed, 22)

From: Taylor Blau <[email-masked]>
Date: Thu, 23 Jan 2025 12:36:56 -0500

On Wed, Jan 22, 2025 at 02:48:43PM -0800, Junio C Hamano wrote:
> * tb/unsafe-hash-cleanup (2025-01-17) 8 commits
>  - hash.h: drop unsafe_ function variants
>  - csum-file: introduce hashfile_checkpoint_init()
>  - t/helper/test-hash.c: use unsafe_hash_algo()
>  - csum-file.c: use unsafe_hash_algo()
>  - hash.h: introduce `unsafe_hash_algo()`
>  - csum-file.c: extract algop from hashfile_checksum_valid()
>  - csum-file: store the hash algorithm as a struct field
>  - t/helper/test-tool: implement sha1-unsafe helper
>
>  The API around choosing to use unsafe variant of SHA-1
>  implementation has been updated in an attempt to make it harder to
>  abuse.
>
>  Expecting a hopefully small and final reroll.
>  cf. <[email-masked]>
>  source: <[email-masked]>

Thanks for the nudge. I sent out a very small reroll of this series as
<[email-masked]>.

> * tb/incremental-midx-part-2 (2024-11-20) 15 commits
>  - midx: implement writing incremental MIDX bitmaps
>  - pack-bitmap.c: use `ewah_or_iterator` for type bitmap iterators
>  - pack-bitmap.c: keep track of each layer's type bitmaps
>  - ewah: implement `struct ewah_or_iterator`
>  - pack-bitmap.c: apply pseudo-merge commits with incremental MIDXs
>  - pack-bitmap.c: compute disk-usage with incremental MIDXs
>  - pack-bitmap.c: teach `rev-list --test-bitmap` about incremental MIDXs
>  - pack-bitmap.c: support bitmap pack-reuse with incremental MIDXs
>  - pack-bitmap.c: teach `show_objects_for_type()` about incremental MIDXs
>  - pack-bitmap.c: teach `bitmap_for_commit()` about incremental MIDXs
>  - pack-bitmap.c: open and store incremental bitmap layers
>  - pack-revindex: prepare for incremental MIDX bitmaps
>  - Documentation: describe incremental MIDX bitmaps
>  - Merge branch 'tb/pseudo-merge-bitmap-fixes' into tb/incremental-midx-part-2
>  - Merge branch 'tb/incremental-midx-part-1' into tb/incremental-midx-part-2
>
>  Incrementally updating multi-pack index files.
>
>  Needs review.
>  source: <[email-masked]>

Yeah, I would really like to see this one progress. I'll gently nudge
Peff (CC'd) as a potential reviewer here.

> * ds/name-hash-tweaks (2024-12-20) 8 commits
>  - pack-objects: add third name hash version
>  - pack-objects: prevent name hash version change
>  - test-tool: add helper for name-hash values
>  - p5313: add size comparison test
>  - pack-objects: add GIT_TEST_NAME_HASH_VERSION
>  - repack: add --name-hash-version option
>  - pack-objects: add --name-hash-version option
>  - pack-objects: create new name-hash function version
>
>  "git pack-objects" and its wrapper "git repack" learned an option
>  to use an alternative path-hash function to improve delta-base
>  selection to produce a packfile with deeper history than window
>  size.
>
>  Will merge to 'next'.
>  (microhalt) <[email-masked]>
>  source: <[email-masked]>

Hmm. I think that the first seven patches are fine as-is (I had some
minor comments on them, but as I noted they are mostly cosmetic and
don't require a reroll IMHO). But I think it would be worth having a
more thorough discussion about the last patch, or at least to hear from
Stolee before proceeding.

Thanks,
Taylor